﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace FlowControl {
  class Program {
    const uint runs = 500000;

    static void Main(string[] args) {
      TestRuns(TestDivByZeroException, runs);
      TestRuns(TestZeroParamBeforeDividing, runs);
    }

    static void TestRuns(Action action, uint runs) {
      Console.Write(String.Format("Testing {0} ({1})... ", action.Method.Name, runs));
      var watch = new Stopwatch( );
      watch.Start( );
      for (uint i = 0; i < runs; i++) {
        action( );
      }
      Console.WriteLine(watch.Elapsed);
    }

    static void TestDivByZeroException( ) {
      int a = 10;
      int b = 0;
      try {
        int c = a / b;
      }
      catch (Exception ex) {
        // do nothing for the test
      }
    }

    static void TestZeroParamBeforeDividing( ) {
      int a = 10;
      int b = 0;
      if (b != 0) {
        int c = a / b;
        // ...
      }
      else {
        // do nothing for the test
      }
    }
  }
}
