﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace RocketLauncher {
  public enum LaunchState {
    Inactive,
    FuseLit,
    Launched
  }

  public class Launcher {
    LaunchState state = LaunchState.Inactive;
    public LaunchState State {
      get { return state; }
    }

    public void LaunchRocket( ) {
      try {
        LightFuse( );
        CountToTen( );
        SetLaunched( );
      }
      finally {
        if (state == LaunchState.FuseLit) {
          Console.WriteLine("Resetting fuse");
          state = LaunchState.Inactive;
        }
      }
    }

    public void AlternativeLaunchRocket( ) {
      try {
        LightFuse( );
        CountToTen( );
        SetLaunched( );
      }
      catch {
        if (state == LaunchState.FuseLit) {
          Console.WriteLine("Resetting fuse");
          state = LaunchState.Inactive;
        }
        throw;
      }
    }

    private void LightFuse( ) {
      state = LaunchState.FuseLit;
      Console.WriteLine("Fuse is lit");
    }

    private void CountToTen( ) {
      Console.WriteLine("Counting to ten...");
      // Do your thing... hey, what if something goes wrong?
      throw new InvalidOperationException("Something went wrong!");
    }

    private void SetLaunched( ) {
      state = LaunchState.Launched;
      Console.WriteLine("Rocket is launched");
    }
  }
}
