﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ThrowingFromHelperMethods {
  class Program {
    static void Main(string[] args) {
    }

    // It's okay to have helper functions that prepare exceptions - they
    // should be private though:
    static Exception CreateArgumentException(string message, string paramName) {
      return new ArgumentException(message, paramName);
    }

    // It's NOT okay to have helper functions that throw exceptions themselves!
    // You don't want this method in the stack trace.
    static void ThrowArgumentException(string message, string paramName) {
      throw new ArgumentException(message, paramName);
    }

  }
}
